<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'user_unix' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class UserUnixMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.UserUnixMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("user_unix");
		$tMap->setPhpName("UserUnix");
		
         
		$tMap->setUseIdGenerator(false);
		 
						
		 
		
		// Add columns to map
		$tMap->addForeignPrimaryKey("USER_ID", "UserId", "int" , CreoleTypes::INTEGER, "user", "USER_ID", true);
		$tMap->addForeignKey("UNIX_SHELL_ID", "UnixShellId", "int", CreoleTypes::INTEGER, "unix_shell" , "UNIX_SHELL_ID", true);
		$tMap->addColumn("UNIX_UID", "UnixUid", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addColumn("UNIX_GID", "UnixGid", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addColumn("AUTHORIZED_KEYS", "AuthorizedKeys", "string", CreoleTypes::VARCHAR, false, null);
				
    }
}
