<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once("session/Login.interface.php");
require_once("exceptions/LoginException.php");
require_once("core/User.php");
require_once("core/UserPeer.php");
require_once("core/UserSession.php");

class DatabaseLogin implements Login {
	/**
	 * @return UserSession
	 */
	public function doLogin($username, $password, $checkStatus=true) {
		$username=strtolower($username);
		$c = new Criteria(UserPeer::DATABASE_NAME);
		$c->add(UserPeer::UNIX_NAME, $username);
		$c->add(UserPeer::PASSWORD_MD5, md5($password));
		if ($checkStatus) {
			$c->add(UserPeer::STATUS, User::STATUS_ACTIVE);
		}
		$user = UserPeer::doSelectOne($c);
		
		if (is_null($user)) {
			throw new LoginException("Invalid username and/or password");
		}
		
		$session = new UserSession();
		$session->setUser($user);
		
		return $session;
	}
	
	public function doLogout() {
	}
}
?>
