<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('plugins/docman/lib/DocmanFileVersionPeer.php');
require_once('lib/core/FilesystemPeer.php');
require_once('exceptions/PermissionDeniedException.php');
//require_once('plugins/docman/lib/InfoParser.php');
require_once('plugins/docman/lib/DocmanTreeRenderer.php');

$session = Session::getSession();
$Lang = $session->getLanguage();
$project=GFUrl::getUrl()->getProject();

require_once('plugins/docman/lib/html/DocmanTemplate.php');
$theme = new DocmanTemplate();

$id = Validator::sanitizeInt($_REQUEST['docman_file_version_id']);

$file_version = DocmanFileVersionPeer::retrieveByPK($id);
if (!is_object($file_version) || $file_version->getDocmanFile()->getDocmanFolder()->getProjectId() != $project->getProjectId()) {
	throw new PermissionDeniedException();
}

$file = $file_version->getDocmanFile();
$file_name = $file->getLatestVersion()->getFile()->getFileName();
$file_version_number = $file_version->getVersionNumber();

//$parser = new InfoParser($project);
//$nested_folders = $parser->getNestedFolders();
//$arranged_folders = $parser->getArrangedFolders();
//$doctreerenderer = new DocmanTreeRenderer($project,$nested_folders,$arranged_folders);
//$subdir = $file->getDocmanFolderId();


$params = array(
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'title' => $Lang->getText('Docman.EditPageTitle'),
	'project' => $project,
	'docman_file' => $file
			);

$file_id = ( isset($_REQUEST['folder_id']) ? htmlspecialchars($_REQUEST['folder_id']) : 0 );
$description = ( isset($_POST['description']) ? htmlspecialchars($_POST['description']) : $file->getDescription() );
$is_locked = ( isset($_POST['is_locked']) ? $_POST['is_locked'] : $file->getIsLocked() );
include('forms/DocmanFileVersionDelete-tpl.php');

?>
