<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a DocmanFolder and saves it to the 
// database
//
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$project = GFUrl::getUrl()->getProject();
$DocmanFolder = new DocmanFolder();
$DocmanFolder->setProject($project);
if ($_POST['parent_folder_id'] > 0) {
	$ParentDocmanFolder = DocmanFolderPeer::retrieveByPk($_POST['parent_folder_id']);
	if (!is_object($ParentDocmanFolder) || !$ParentDocmanFolder->userCanUpdate()) {
		throw new PermissionDeniedException();
	}
	if ($ParentDocmanFolder->getProject()->getProjectId() != $project->getProjectId()) {
		throw new PermissionDeniedException();
	}
	$DocmanFolder->setParentFolderId($_POST['parent_folder_id']);
}

$Lang = Language::getSessLang();

$is_public = ((isset($_POST) && isset($_POST['is_public'])) ? $_POST['is_public'] : 0);

try {
	$DocmanFolder->setFolderName( Validator::sanitizeString($_POST['folder_name']) );
	$DocmanFolder->setIsPublic( Validator::sanitizeBool($is_public) );
	
	$DocmanFolder->save();
	$url = GFUrl::getUrl();
	GFUrl::redirect($url->currentBaseURL('DocmanFolderBrowse'), array('feedback' => $Lang->getText('DocmanFolder.AddFeedback')));
} catch (InvalidDataException $ex) {
	$errors=$ex->getErrors();
	$feedback = implode('<br />', $errors);
	include('DocmanFolderAdd.php');
}

?>
