<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new FrsPackage and saves it to the 
// database
//
require_once('plugins/frs/lib/FrsPackage.php');
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$Project = GFUrl::getURL()->getProject();
$FrsPackage = new FrsPackage();
$FrsPackage->setProject($Project);

$Lang = Language::getSessLang();

$errors = array();

try {
	//names are sanitized internally
	$FrsPackage->setPackageName( ((isset($_POST['package_name'])) ? $_POST['package_name'] : '') );
	$FrsPackage->setStatusId( (isset($_POST['status_id']) ? FrsPackage::STATUS_ACTIVE : FrsPackage::STATUS_HIDDEN ) );
	$FrsPackage->setIsPublic( (isset($_POST['is_public']) ? 1 : 0 ) );
	$FrsPackage->setRequireLogin( (isset($_POST['require_login']) ? 1 : 0 ) );
	
	$FrsPackage->save();
	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL(''), array('feedback' => $Lang->getText('FrsPackage.AddFeedback')));
} catch (InvalidDataException $ex) {
	$errors = array_merge($errors, $ex->getErrors());		// attach object errors to validation errors
	$feedback = '* '.implode('<br />* ', $errors);
	include('FrsPackageAdd.php');
}

?>
