<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'plugins/news/lib/NewsPeer.php';

/**
 * Base class that represents a row from the 'news' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to News class. 
 * 
 * @package plugins.news.lib 
 */
abstract class BaseNews extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var NewsPeer
	 */
	protected static $peer;

	/**
	 * The value for the news_id field.
	 * @var int	  
	 */
	protected $news_id;	

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the submitted_by field.
	 * @var int	  
	 */
	protected $submitted_by;	

	/**
	 * The value for the is_approved field.
	 * @var boolean	  
	 */
	protected $is_approved = true;	

	/**
	 * The value for the post_date field.
	 * @var int	  
	 */
	protected $post_date = -1;	

	/**
	 * The value for the summary field.
	 * @var string	  
	 */
	protected $summary;	

	/**
	 * The value for the details field.
	 * @var string	  
	 */
	protected $details;	
  
	/**
	 * Get the NewsId column value.
	 *  
	 * @return int	  
	 */
	public function getNewsId()
	{
		return $this->news_id;
	}


	/**
	 * Set the value of `news_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setNewsId($v)
	{
		if ($this->news_id !== $v) {
			$this->news_id = $v;
			$this->modifiedColumns[] = NewsPeer::NEWS_ID;
		}
				
	}

  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = NewsPeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the SubmittedBy column value.
	 *  
	 * @return int	  
	 */
	public function getSubmittedBy()
	{
		return $this->submitted_by;
	}


	/**
	 * Set the value of `submitted_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setSubmittedBy($v)
	{
		if ($this->submitted_by !== $v) {
			$this->submitted_by = $v;
			$this->modifiedColumns[] = NewsPeer::SUBMITTED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the IsApproved column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsApproved()
	{
		return $this->is_approved;
	}


	/**
	 * Set the value of `is_approved` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsApproved($v)
	{
		if ($this->is_approved !== $v || $v === true) {
			$this->is_approved = $v;
			$this->modifiedColumns[] = NewsPeer::IS_APPROVED;
		}
				
	}


	/**
	 * Get the [optionally formatted] `post_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getPostDate($format = 'Y-m-d H:i:s')
	{
		if ($this->post_date === null || $this->post_date === '') {
			return null;
		} elseif (!is_int($this->post_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->post_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of post_date as date/time value: " . var_export($this->post_date, true));
			}
		} else {
			$ts = $this->post_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `post_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setPostDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for post_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->post_date !== $ts || $ts === -1) {
			$this->post_date = $ts;
			$this->modifiedColumns[] = NewsPeer::POST_DATE;
		}
		
	}

  
	/**
	 * Get the Summary column value.
	 *  
	 * @return string	  
	 */
	public function getSummary()
	{
		return $this->summary;
	}


	/**
	 * Set the value of `summary` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSummary($v)
	{
		if ($this->summary !== $v) {
			$this->summary = $v;
			$this->modifiedColumns[] = NewsPeer::SUMMARY;
		}
				
	}

  
	/**
	 * Get the Details column value.
	 *  
	 * @return string	  
	 */
	public function getDetails()
	{
		return $this->details;
	}


	/**
	 * Set the value of `details` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDetails($v)
	{
		if ($this->details !== $v) {
			$this->details = $v;
			$this->modifiedColumns[] = NewsPeer::DETAILS;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->news_id = $rs->getInt($startcol + 0);					
			$this->project_id = $rs->getInt($startcol + 1);					
			$this->submitted_by = $rs->getInt($startcol + 2);					
			$this->is_approved = $rs->getBoolean($startcol + 3);					
			$this->post_date = $rs->getTimestamp($startcol + 4, null);
			$this->summary = $rs->getString($startcol + 5);					
			$this->details = $rs->getString($startcol + 6);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating News object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(NewsPeer::DATABASE_NAME);
		$criteria->add(NewsPeer::NEWS_ID, $this->news_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(NewsPeer::DATABASE_NAME);
		if ($this->isColumnModified(NewsPeer::NEWS_ID)) $criteria->add(NewsPeer::NEWS_ID, $this->news_id);
		if ($this->isColumnModified(NewsPeer::PROJECT_ID)) $criteria->add(NewsPeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(NewsPeer::SUBMITTED_BY)) $criteria->add(NewsPeer::SUBMITTED_BY, $this->submitted_by);
		if ($this->isColumnModified(NewsPeer::IS_APPROVED)) $criteria->add(NewsPeer::IS_APPROVED, $this->is_approved);
		if ($this->isColumnModified(NewsPeer::POST_DATE)) $criteria->add(NewsPeer::POST_DATE, $this->post_date);
		if ($this->isColumnModified(NewsPeer::SUMMARY)) $criteria->add(NewsPeer::SUMMARY, $this->summary);
		if ($this->isColumnModified(NewsPeer::DETAILS)) $criteria->add(NewsPeer::DETAILS, $this->details);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addNewss($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setSubmittedBy(NULL);
		} else {
			$this->setSubmittedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->submitted_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->submitted_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->submitted_by, $con);
			   $obj->addNewss($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setSubmittedBy( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("news_id", "project_id", "submitted_by", "is_approved", "post_date", "summary", "details", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case NewsPeer::NEWS_ID:
				return $this->getNewsId();
				break;
		  
			case NewsPeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case NewsPeer::SUBMITTED_BY:
				return $this->getSubmittedBy();
				break;
		  
			case NewsPeer::IS_APPROVED:
				return $this->getIsApproved();
				break;
		  
			case NewsPeer::POST_DATE:
				return $this->getPostDate();
				break;
		  
			case NewsPeer::SUMMARY:
				return $this->getSummary();
				break;
		  
			case NewsPeer::DETAILS:
				return $this->getDetails();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getNewsId();
				break;
  
			case 1:
				return $this->getProjectId();
				break;
  
			case 2:
				return $this->getSubmittedBy();
				break;
  
			case 3:
				return $this->getIsApproved();
				break;
  
			case 4:
				return $this->getPostDate();
				break;
  
			case 5:
				return $this->getSummary();
				break;
  
			case 6:
				return $this->getDetails();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(NewsPeer::NEWS_ID, $arr)) $this->setNewsId($arr[NewsPeer::NEWS_ID]);
  
		if (array_key_exists(NewsPeer::PROJECT_ID, $arr)) $this->setProjectId($arr[NewsPeer::PROJECT_ID]);
  
		if (array_key_exists(NewsPeer::SUBMITTED_BY, $arr)) $this->setSubmittedBy($arr[NewsPeer::SUBMITTED_BY]);
  
		if (array_key_exists(NewsPeer::IS_APPROVED, $arr)) $this->setIsApproved($arr[NewsPeer::IS_APPROVED]);
  
		if (array_key_exists(NewsPeer::POST_DATE, $arr)) $this->setPostDate($arr[NewsPeer::POST_DATE]);
  
		if (array_key_exists(NewsPeer::SUMMARY, $arr)) $this->setSummary($arr[NewsPeer::SUMMARY]);
  
		if (array_key_exists(NewsPeer::DETAILS, $arr)) $this->setDetails($arr[NewsPeer::DETAILS]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case NewsPeer::NEWS_ID:
				$this->setNewsId($value);
				break;
	  
			case NewsPeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case NewsPeer::SUBMITTED_BY:
				$this->setSubmittedBy($value);
				break;
	  
			case NewsPeer::IS_APPROVED:
				$this->setIsApproved($value);
				break;
	  
			case NewsPeer::POST_DATE:
				$this->setPostDate($value);
				break;
	  
			case NewsPeer::SUMMARY:
				$this->setSummary($value);
				break;
	  
			case NewsPeer::DETAILS:
				$this->setDetails($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setNewsId($value);
				break;
  
			case 1:
				$this->setProjectId($value);
				break;
  
			case 2:
				$this->setSubmittedBy($value);
				break;
  
			case 3:
				$this->setIsApproved($value);
				break;
  
			case 4:
				$this->setPostDate($value);
				break;
  
			case 5:
				$this->setSummary($value);
				break;
  
			case 6:
				$this->setDetails($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(NewsPeer::DATABASE_NAME);

		try {
			$con->begin();
			NewsPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(NewsPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = NewsPeer::doInsert($this, $con);
					$this->setNewsId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					NewsPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return NewsPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = NewsPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed news_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setNewsId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getNewsId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return News Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new News();
		$copyObj->setProjectId($this->project_id);
		$copyObj->setSubmittedBy($this->submitted_by);
		$copyObj->setIsApproved($this->is_approved);
		$copyObj->setPostDate($this->post_date);
		$copyObj->setSummary($this->summary);
		$copyObj->setDetails($this->details);
		
		$copyObj->setNew(true);
		
		$copyObj->setNewsId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return NewsPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new NewsPeer();
		}
		return self::$peer;
	}

}
