<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: ScmServer.php 3226 2008-08-06 17:58:08Z bigdisk $
 * @author Tim Perdue tim@gforge.org
 * @date 2006-01-03
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/scm/lib/om/BaseScmServer.php');
require_once("plugin/ActionManager.php");
require_once('html/GFWidget.php');

/** 
 * The skeleton for this class was autogenerated by Propel  on:
 *
 * [Wed Jan  4 05:51:25 2006]
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package plugins.scm.lib 
 */
class ScmServer extends BaseScmServer implements GFWidget {
	
	function userCanDelete() {
		return Session::getSession()->isSiteAdmin();
	}

	function userCanCreate() {
		return Session::getSession()->isSiteAdmin();
	}
	
	function userCanUpdate() {
		return Session::getSession()->isSiteAdmin();
	}

	/**
	 * Removes this object from datastore and sets delete attribute. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see ScmServer::setDeleted()
	 * @see ScmServer::isDeleted()
	 */
	function delete($con = null) {
		ActionManager::notify("SCM_SERVER_DELETE", $this);
		parent::delete($con);		
	}

	/**
	 * Stores the object in the database using the Propel methods. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	function save($con = null) {
		$errors = array();
		
		if (empty($this->scm_type)) {
			$errors['scm_type'] = Language::getSessText('ScmServer.EmptyScmType');
		}
		if (empty($this->hostname)) {
			$errors['hostname'] = Language::getSessText('ScmServer.EmptyHostname');
		}
		
		if (!empty($errors)) {
			throw new InvalidDataException($errors);
		}

		parent::save($con);
		ActionManager::notify("SCM_SERVER_SAVE", $this);
	}
	
	/**
	 * Return the name of the server -- needed for GFWidget
	 * @return	string
	 */
	public function getName() {
		return $this->getHostname();
	}
	
	/**
	 * Return the ID of the server -- needed for GFWidget
	 * @return	int
	 */
	public function getId() {
		return $this->getScmServerId();
	}
}
?>