<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'scm_module' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.scm.lib.map
 */
class ScmModuleMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.scm.lib.map.ScmModuleMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("scm_module");
		$tMap->setPhpName("ScmModule");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("scm_module_scm_module_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("SCM_MODULE_ID", "ScmModuleId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("PROJECT_ID", "ProjectId", "int", CreoleTypes::INTEGER, "project" , "PROJECT_ID", true);
		$tMap->addColumn("PATH", "Path", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("PUBLISH_TO_WWW", "PublishToWww", "boolean", CreoleTypes::BOOLEAN, false, null);
				
    }
}
