<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/tracker/lib/Tracker.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerPeer.php';
 

// (on-demand) include_once 'plugins/tracker/lib/TrackerExtraField.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerExtraFieldPeer.php';
 

// (on-demand) include_once 'plugins/tracker/lib/TrackerExtraFieldElement.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerExtraFieldElementPeer.php';

include_once 'plugins/tracker/lib/TrackerCommitTriggerPeer.php';

/**
 * Base class that represents a row from the 'tracker_commit_trigger' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TrackerCommitTrigger class. 
 * 
 * @package plugins.tracker.lib 
 */
abstract class BaseTrackerCommitTrigger extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TrackerCommitTriggerPeer
	 */
	protected static $peer;

	/**
	 * The value for the tracker_commit_trigger_id field.
	 * @var int	  
	 */
	protected $tracker_commit_trigger_id;	

	/**
	 * The value for the tracker_id field.
	 * @var int	  
	 */
	protected $tracker_id;	

	/**
	 * The value for the change_tracker_extra_field_id field.
	 * @var int	  
	 */
	protected $change_tracker_extra_field_id;	

	/**
	 * The value for the to_element_id field.
	 * @var int	  
	 */
	protected $to_element_id;	
  
	/**
	 * Get the TrackerCommitTriggerId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerCommitTriggerId()
	{
		return $this->tracker_commit_trigger_id;
	}


	/**
	 * Set the value of `tracker_commit_trigger_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setTrackerCommitTriggerId($v)
	{
		if ($this->tracker_commit_trigger_id !== $v) {
			$this->tracker_commit_trigger_id = $v;
			$this->modifiedColumns[] = TrackerCommitTriggerPeer::TRACKER_COMMIT_TRIGGER_ID;
		}
				
	}

  
	/**
	 * Get the TrackerId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerId()
	{
		return $this->tracker_id;
	}


	/**
	 * Set the value of `tracker_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerId($v)
	{
		if ($this->tracker_id !== $v) {
			$this->tracker_id = $v;
			$this->modifiedColumns[] = TrackerCommitTriggerPeer::TRACKER_ID;
		}
			
		if ($this->aTracker !== null && $this->aTracker->getTrackerId() !== $v) {
			$this->aTracker = null;
		}
			
	}

  
	/**
	 * Get the ChangeTrackerExtraFieldId column value.
	 *  
	 * @return int	  
	 */
	public function getChangeTrackerExtraFieldId()
	{
		return $this->change_tracker_extra_field_id;
	}


	/**
	 * Set the value of `change_tracker_extra_field_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setChangeTrackerExtraFieldId($v)
	{
		if ($this->change_tracker_extra_field_id !== $v) {
			$this->change_tracker_extra_field_id = $v;
			$this->modifiedColumns[] = TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID;
		}
			
		if ($this->aTrackerExtraField !== null && $this->aTrackerExtraField->getTrackerExtraFieldId() !== $v) {
			$this->aTrackerExtraField = null;
		}
			
	}

  
	/**
	 * Get the ToElementId column value.
	 *  
	 * @return int	  
	 */
	public function getToElementId()
	{
		return $this->to_element_id;
	}


	/**
	 * Set the value of `to_element_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setToElementId($v)
	{
		if ($this->to_element_id !== $v) {
			$this->to_element_id = $v;
			$this->modifiedColumns[] = TrackerCommitTriggerPeer::TO_ELEMENT_ID;
		}
			
		if ($this->aTrackerExtraFieldElement !== null && $this->aTrackerExtraFieldElement->getElementId() !== $v) {
			$this->aTrackerExtraFieldElement = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->tracker_commit_trigger_id = $rs->getInt($startcol + 0);					
			$this->tracker_id = $rs->getInt($startcol + 1);					
			$this->change_tracker_extra_field_id = $rs->getInt($startcol + 2);					
			$this->to_element_id = $rs->getInt($startcol + 3);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TrackerCommitTrigger object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TrackerCommitTriggerPeer::DATABASE_NAME);
		$criteria->add(TrackerCommitTriggerPeer::TRACKER_COMMIT_TRIGGER_ID, $this->tracker_commit_trigger_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TrackerCommitTriggerPeer::DATABASE_NAME);
		if ($this->isColumnModified(TrackerCommitTriggerPeer::TRACKER_COMMIT_TRIGGER_ID)) $criteria->add(TrackerCommitTriggerPeer::TRACKER_COMMIT_TRIGGER_ID, $this->tracker_commit_trigger_id);
		if ($this->isColumnModified(TrackerCommitTriggerPeer::TRACKER_ID)) $criteria->add(TrackerCommitTriggerPeer::TRACKER_ID, $this->tracker_id);
		if ($this->isColumnModified(TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID)) $criteria->add(TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->change_tracker_extra_field_id);
		if ($this->isColumnModified(TrackerCommitTriggerPeer::TO_ELEMENT_ID)) $criteria->add(TrackerCommitTriggerPeer::TO_ELEMENT_ID, $this->to_element_id);
		return $criteria;			
	}
	
	

	/**
	 * @var Tracker	  
	 */
	protected $aTracker;

	/**
	 * Declares an association between this object and a Tracker object
	 *
	 * @param Tracker $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTracker($v)
	{
			
		if ($v === null) {
			$this->setTrackerId(NULL);
		} else {
			$this->setTrackerId($v->getTrackerId());
		}
   
		$this->aTracker = $v;
	}


	/**
	 * Get the associated Tracker object
	 *
	 * @param Connection Optional Connection object.
	 * @return Tracker The associated Tracker object.
	 * @throws PropelException
	 */
	public function getTracker($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerPeer.php';

		if ($this->aTracker === null && ($this->tracker_id !== null)) {
	
			$this->aTracker = TrackerPeer::retrieveByPK($this->tracker_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerPeer::retrieveByPK($this->tracker_id, $con);
			   $obj->addTrackerCommitTriggers($this);
			 */
		}
		return $this->aTracker;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerKey($key)
	{

		$this->setTrackerId( (int) $key);			
		
	}

	/**
	 * @var TrackerExtraField	  
	 */
	protected $aTrackerExtraField;

	/**
	 * Declares an association between this object and a TrackerExtraField object
	 *
	 * @param TrackerExtraField $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerExtraField($v)
	{
			
		if ($v === null) {
			$this->setChangeTrackerExtraFieldId(NULL);
		} else {
			$this->setChangeTrackerExtraFieldId($v->getTrackerExtraFieldId());
		}
   
		$this->aTrackerExtraField = $v;
	}


	/**
	 * Get the associated TrackerExtraField object
	 *
	 * @param Connection Optional Connection object.
	 * @return TrackerExtraField The associated TrackerExtraField object.
	 * @throws PropelException
	 */
	public function getTrackerExtraField($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldPeer.php';

		if ($this->aTrackerExtraField === null && ($this->change_tracker_extra_field_id !== null)) {
	
			$this->aTrackerExtraField = TrackerExtraFieldPeer::retrieveByPK($this->change_tracker_extra_field_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerExtraFieldPeer::retrieveByPK($this->change_tracker_extra_field_id, $con);
			   $obj->addTrackerCommitTriggers($this);
			 */
		}
		return $this->aTrackerExtraField;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerExtraFieldKey($key)
	{

		$this->setChangeTrackerExtraFieldId( (int) $key);			
		
	}

	/**
	 * @var TrackerExtraFieldElement	  
	 */
	protected $aTrackerExtraFieldElement;

	/**
	 * Declares an association between this object and a TrackerExtraFieldElement object
	 *
	 * @param TrackerExtraFieldElement $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerExtraFieldElement($v)
	{
			
		if ($v === null) {
			$this->setToElementId(NULL);
		} else {
			$this->setToElementId($v->getElementId());
		}
   
		$this->aTrackerExtraFieldElement = $v;
	}


	/**
	 * Get the associated TrackerExtraFieldElement object
	 *
	 * @param Connection Optional Connection object.
	 * @return TrackerExtraFieldElement The associated TrackerExtraFieldElement object.
	 * @throws PropelException
	 */
	public function getTrackerExtraFieldElement($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldElementPeer.php';

		if ($this->aTrackerExtraFieldElement === null && ($this->to_element_id !== null)) {
	
			$this->aTrackerExtraFieldElement = TrackerExtraFieldElementPeer::retrieveByPK($this->to_element_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerExtraFieldElementPeer::retrieveByPK($this->to_element_id, $con);
			   $obj->addTrackerCommitTriggers($this);
			 */
		}
		return $this->aTrackerExtraFieldElement;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerExtraFieldElementKey($key)
	{

		$this->setToElementId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("tracker_commit_trigger_id", "tracker_id", "change_tracker_extra_field_id", "to_element_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TrackerCommitTriggerPeer::TRACKER_COMMIT_TRIGGER_ID:
				return $this->getTrackerCommitTriggerId();
				break;
		  
			case TrackerCommitTriggerPeer::TRACKER_ID:
				return $this->getTrackerId();
				break;
		  
			case TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID:
				return $this->getChangeTrackerExtraFieldId();
				break;
		  
			case TrackerCommitTriggerPeer::TO_ELEMENT_ID:
				return $this->getToElementId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getTrackerCommitTriggerId();
				break;
  
			case 1:
				return $this->getTrackerId();
				break;
  
			case 2:
				return $this->getChangeTrackerExtraFieldId();
				break;
  
			case 3:
				return $this->getToElementId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TrackerCommitTriggerPeer::TRACKER_COMMIT_TRIGGER_ID, $arr)) $this->setTrackerCommitTriggerId($arr[TrackerCommitTriggerPeer::TRACKER_COMMIT_TRIGGER_ID]);
  
		if (array_key_exists(TrackerCommitTriggerPeer::TRACKER_ID, $arr)) $this->setTrackerId($arr[TrackerCommitTriggerPeer::TRACKER_ID]);
  
		if (array_key_exists(TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $arr)) $this->setChangeTrackerExtraFieldId($arr[TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID]);
  
		if (array_key_exists(TrackerCommitTriggerPeer::TO_ELEMENT_ID, $arr)) $this->setToElementId($arr[TrackerCommitTriggerPeer::TO_ELEMENT_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TrackerCommitTriggerPeer::TRACKER_COMMIT_TRIGGER_ID:
				$this->setTrackerCommitTriggerId($value);
				break;
	  
			case TrackerCommitTriggerPeer::TRACKER_ID:
				$this->setTrackerId($value);
				break;
	  
			case TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID:
				$this->setChangeTrackerExtraFieldId($value);
				break;
	  
			case TrackerCommitTriggerPeer::TO_ELEMENT_ID:
				$this->setToElementId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setTrackerCommitTriggerId($value);
				break;
  
			case 1:
				$this->setTrackerId($value);
				break;
  
			case 2:
				$this->setChangeTrackerExtraFieldId($value);
				break;
  
			case 3:
				$this->setToElementId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerCommitTriggerPeer::DATABASE_NAME);

		try {
			$con->begin();
			TrackerCommitTriggerPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerCommitTriggerPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aTracker !== null) {
				if ($this->aTracker->isModified()) $this->aTracker->save($con);
				$this->setTracker($this->aTracker);
			}
 
			if ($this->aTrackerExtraField !== null) {
				if ($this->aTrackerExtraField->isModified()) $this->aTrackerExtraField->save($con);
				$this->setTrackerExtraField($this->aTrackerExtraField);
			}
 
			if ($this->aTrackerExtraFieldElement !== null) {
				if ($this->aTrackerExtraFieldElement->isModified()) $this->aTrackerExtraFieldElement->save($con);
				$this->setTrackerExtraFieldElement($this->aTrackerExtraFieldElement);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TrackerCommitTriggerPeer::doInsert($this, $con);
					$this->setTrackerCommitTriggerId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					TrackerCommitTriggerPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TrackerCommitTriggerPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aTracker !== null) {
				if (($retval = $this->aTracker->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aTrackerExtraField !== null) {
				if (($retval = $this->aTrackerExtraField->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aTrackerExtraFieldElement !== null) {
				if (($retval = $this->aTrackerExtraFieldElement->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TrackerCommitTriggerPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed tracker_commit_trigger_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setTrackerCommitTriggerId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getTrackerCommitTriggerId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TrackerCommitTrigger Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TrackerCommitTrigger();
		$copyObj->setTrackerId($this->tracker_id);
		$copyObj->setChangeTrackerExtraFieldId($this->change_tracker_extra_field_id);
		$copyObj->setToElementId($this->to_element_id);
		
		$copyObj->setNew(true);
		
		$copyObj->setTrackerCommitTriggerId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TrackerCommitTriggerPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TrackerCommitTriggerPeer();
		}
		return self::$peer;
	}

}
