<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for Tracker
//
require_once('plugins/tracker/lib/TrackerPeer.php');
require_once('plugins/tracker/lib/Tracker.php');
require_once('GFUrl.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('lib/html/ProjectTemplate.php');
$theme = new ProjectTemplate();

$Project = GFUrl::getUrl()->getProject();
if (!$Project->getPermission()->check(Tracker::SECTION,0,Tracker::PERMLEVEL_ADMIN)) {
	throw new PermissionDeniedException();
}

$params = array(
		'selectedbottomtab'=>'tracker',
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Tracker.AddNewPageTitle')
		);
$theme->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','tracker','admin').'">'.$Lang->getText('Tabs.Admin').'</a>');
$theme->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','tracker').'">'.$Lang->getText('Tracker.TabString').'</a>');

$tracker_name=((isset($_POST['tracker_name'])) ? htmlspecialchars($_POST['tracker_name']) : '' );
$description=((isset($_POST['description'])) ? htmlspecialchars($_POST['description']) : '' );
$is_public=((isset($_POST['is_public'])) ? htmlspecialchars($_POST['is_public']) : '' );
$restrict_browse=((isset($_POST['restrict_browse'])) ? htmlspecialchars($_POST['restrict_browse']) : '' );
$email_all_updates=((isset($_POST['email_all_updates'])) ? htmlspecialchars($_POST['email_all_updates']) : '' );
$email_address=((isset($_POST['email_address'])) ? htmlspecialchars($_POST['email_address']) : '' );
$due_period=((isset($_POST['due_period'])) ? htmlspecialchars($_POST['due_period']) : '' );
$submit_instructions=((isset($_POST['submit_instructions'])) ? htmlspecialchars($_POST['submit_instructions']) : '' );
$browse_instructions=((isset($_POST['browse_instructions'])) ? htmlspecialchars($_POST['browse_instructions']) : '' );
$datatype=((isset($_POST['datatype'])) ? htmlspecialchars($_POST['datatype']) : Tracker::DATATYPE_TRACKER );
$clone_tracker=(isset($_POST['clone_tracker'])) ? true : false;
$clone_tracker_id=(isset($_POST['clone_tracker_id']) ? $_POST['clone_tracker_id'] : 0);

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
	$show_dependencies_tab = (isset($_POST['show_dependencies_tab']) ? true : false);
	$show_duplicates_tab = (isset($_POST['show_duplicates_tab']) ? true : false);
	$show_associations_tab = (isset($_POST['show_associations_tab']) ? true : false);
	$show_time_tracking_tab = (isset($_POST['show_time_tracking_tab']) ? true : false);
	$show_tags_tab = (isset($_POST['show_tags_tab']) ? true : false);
} else {
	$show_dependencies_tab = true;
	$show_duplicates_tab = true;
	$show_associations_tab = true;
	$show_time_tracking_tab = true;
	$show_tags_tab = true;
}

include('forms/TrackerAdd-tpl.php');

?>
