<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new TrackerExtraFieldElement and saves it to the 
// database
//
require_once('plugins/tracker/lib/TrackerExtraFieldElement.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Project = GFUrl::getUrl()->getProject();
$TrackerExtraFieldElement = TrackerExtraFieldElementPeer::retrieveByPk($_REQUEST['element_id']);
$Tracker=$TrackerExtraFieldElement->getTrackerExtraField()->getTracker();

if ($_POST['sure']) {
	if (!is_object($Tracker) || !$Tracker->userIsAdmin()
		|| $Tracker->getProject()->getProjectId() != $Project->getProjectId()) {
		throw new PermissionDeniedException();
	} else {
		$TrackerExtraFieldElement->delete();
		GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldElementBrowse'), array('feedback' => Language::getSessLang()->getText('TrackerExtraFieldElement.DeleteFeedback'), 'tracker_extra_field_id'=>$TrackerExtraFieldElement->getTrackerExtraField()->getTrackerExtraFieldId()));
	}
} else {
	$feedback = Language::getSessLang()->getText('TrackerExtraFieldElementDeleteForm.DidntConfirm');
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldElementBrowse'), array('feedback' =>$feedback, 'tracker_extra_field_id'=>$TrackerExtraFieldElement->getTrackerExtraField()->getTrackerExtraFieldId()));
}

?>
