<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new TrackerExtraFieldElementTransition and saves it to the 
// database
//
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransition.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransitionRole.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransitionNotify.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransitionField.php');
require_once('plugins/tracker/lib/TrackerEfeTransitionReassign.php');
require_once('plugins/tracker/lib/TrackerEfeTransitionTrigger.php');
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$session = Session::getSession();
$Lang = $session->getLanguage();
$project = GFUrl::getUrl()->getProject();
$TrackerExtraFieldElement = TrackerExtraFieldElementPeer::retrieveByPk($_REQUEST['element_id']);
$Tracker = $TrackerExtraFieldElement->getTrackerExtraField()->getTracker();
if (!is_object($Tracker) || !$Tracker->userIsAdmin()) {
	throw new PermissionDeniedException();
}

$TrackerExtraFieldElementTransition = new TrackerExtraFieldElementTransition();

try {
	$TrackerExtraFieldElementTransition->setElementId( Validator::sanitizeInt($_POST['element_id']) );
	$TrackerExtraFieldElementTransition->setToElementId( Validator::sanitizeInt($_POST['to_element_id']) );

	if (isset($_REQUEST['role_id']) && is_array($_REQUEST['role_id']) && count($_REQUEST['role_id']) > 0) {
		foreach ($_REQUEST['role_id'] as $role) {
			if ($role == '') {

			} else {

				$tefetr=new TrackerExtraFieldElementTransitionRole();
				$tefetr->setRoleId($role);
				$TrackerExtraFieldElementTransition->addTrackerExtraFieldElementTransitionRole($tefetr);
			}
		}
	}
	if (isset($_REQUEST['notify_role_id']) && is_array($_REQUEST['notify_role_id']) && count($_REQUEST['notify_role_id']) > 0) {
		foreach ($_REQUEST['notify_role_id'] as $role) {
			if ($role == '') {

			} else {

				$tefetr=new TrackerExtraFieldElementTransitionNotify();
				$tefetr->setRoleId($role);
				$TrackerExtraFieldElementTransition->addTrackerExtraFieldElementTransitionNotify($tefetr);
			}
		}
	}
	if (isset($_REQUEST['reassign_to_role_id']) && is_array($_REQUEST['reassign_to_role_id']) && count($_REQUEST['reassign_to_role_id']) > 0) {
		foreach ($_REQUEST['reassign_to_role_id'] as $role) {
			if ($role == '') {

			} else {

				$tefetr=new TrackerEfeTransitionReassign();
				$tefetr->setAssignToRoleId($role);
				$TrackerExtraFieldElementTransition->addTrackerEfeTransitionReassign($tefetr);
			}
		}
	}
	if (isset($_REQUEST['tracker_extra_field_id']) && is_array($_REQUEST['tracker_extra_field_id']) && count($_REQUEST['tracker_extra_field_id']) > 0) {
		foreach ($_REQUEST['tracker_extra_field_id'] as $fieldid) {
			if ($fieldid == '') {

			} else {
				$tefetr=new TrackerExtraFieldElementTransitionField();
				$tefetr->setRequiredTrackerExtraFieldId($fieldid);
				$TrackerExtraFieldElementTransition->addTrackerExtraFieldElementTransitionField($tefetr);
			}
		}
	}
	$TrackerExtraFieldElementTransition->setNotificationMessage(Validator::sanitizeString($_REQUEST['notification_message']));
	$TrackerExtraFieldElementTransition->save();

	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldElementTransitionBrowse'), array('feedback' => $Lang->getText('TrackerExtraFieldElementTransition.AddFeedback'),'element_id'=>$_POST['element_id']));
} catch (InvalidDataException $ex) {
	$errors = array_merge($errors, $ex->getErrors());		// attach object errors to validation errors
	$feedback = '* '.implode('<br />* ', $errors);
	include('TrackerExtraFieldElementTransitionAdd.php');

}
?>
