<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


require_once('plugins/userwiki/lib/Wiki.php');
require_once('lib/Validator.php');

$components = GFUrl::getUrl()->getURI();
$arr = explode('/',$components);
if (in_array('my',$arr)) {
	require_once('plugins/userwiki/lib/html/WikiMyTemplate.php');
	$theme = new WikiMyTemplate();
} else {
	require_once('plugins/userwiki/lib/html/WikiUserTemplate.php');
	$theme = new WikiUserTemplate();
}

$user = GFUrl::getUrl()->getUser();

$section = User::SECTION;
$ref_id = $user->getUserId();

$post = (isset($_REQUEST['post'])) ? Validator::sanitizeString($_REQUEST['post']) : null;
$editversion = (isset($_REQUEST['editversion'])) ? Validator::sanitizeInt($_REQUEST['editversion']) : null;
$is_new = (isset($_REQUEST['is_new']) && $_REQUEST['is_new']=='true') ? true : false;
$content = (isset($_REQUEST['content'])) ? Validator::sanitizeHtml($_REQUEST['content']) : null;
$archive = (isset($_REQUEST['minor_edit'])) ? false : true;
$parent_page = (isset($_REQUEST['parent_page'])) ? Validator::sanitizeString($_REQUEST['parent_page']) : null;

$submit = (isset($_REQUEST['submit'])) ? true : false;

$parms = array('ref_id'=>$ref_id,'section'=>$section);
		
if ($submit) {
	$wiki = new UserWiki('user',$user->getUserId(),$theme,$user);
	if ($is_new) {
		//create new version and page
		$id = $wiki->createNewPage($post,Validator::sanitizeHtml($content));
		if ($parent_page) {
			$c = new Criteria();
			$c->add(UserWikiPagePeer::SECTION,'user');
			$c->add(UserWikiPagePeer::REF_ID,$user->getUserId());
			$c->add(UserWikiPagePeer::PAGENAME,$parent_page);
			$ParentWiki = UserWikiPagePeer::doSelectOne($c);
			if (is_object($ParentWiki)) {
				$parent_wiki = new UserWiki('user',$user->getUserId(),$theme,$user);
				$parent_wiki->updateLinks($ParentWiki,$ParentWiki->getLatestContents());
			}
		}
	} else {
		//update the version
		$id = $wiki->updatePage($editversion,Validator::sanitizeHtml($content),$archive);
	}
	$parms['pageid'] = $id;
	$feedback = 'Edited ok';
} else {
	$feedback = 'ERROR - invalid params';
}

$parms['feedback'] = $feedback;
GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), $parms);

?>
