<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';

include_once 'plugins/wiki/lib/WikiProjectSettingPeer.php';

/**
 * Base class that represents a row from the 'wiki_project_setting' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to WikiProjectSetting class. 
 * 
 * @package plugins.wiki.lib 
 */
abstract class BaseWikiProjectSetting extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var WikiProjectSettingPeer
	 */
	protected static $peer;

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the is_public field.
	 * @var boolean	  
	 */
	protected $is_public = true;	

	/**
	 * The value for the wiki_type field.
	 * @var int	  
	 */
	protected $wiki_type;	

	/**
	 * The value for the show_associations_tab field.
	 * @var boolean	  
	 */
	protected $show_associations_tab = true;	

	/**
	 * The value for the show_tags_tab field.
	 * @var boolean	  
	 */
	protected $show_tags_tab = true;	
  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = WikiProjectSettingPeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the IsPublic column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsPublic()
	{
		return $this->is_public;
	}


	/**
	 * Set the value of `is_public` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsPublic($v)
	{
		if ($this->is_public !== $v || $v === true) {
			$this->is_public = $v;
			$this->modifiedColumns[] = WikiProjectSettingPeer::IS_PUBLIC;
		}
				
	}

  
	/**
	 * Get the WikiType column value.
	 *  
	 * @return int	  
	 */
	public function getWikiType()
	{
		return $this->wiki_type;
	}


	/**
	 * Set the value of `wiki_type` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setWikiType($v)
	{
		if ($this->wiki_type !== $v) {
			$this->wiki_type = $v;
			$this->modifiedColumns[] = WikiProjectSettingPeer::WIKI_TYPE;
		}
				
	}

  
	/**
	 * Get the ShowAssociationsTab column value.
	 *  
	 * @return boolean	  
	 */
	public function getShowAssociationsTab()
	{
		return $this->show_associations_tab;
	}


	/**
	 * Set the value of `show_associations_tab` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setShowAssociationsTab($v)
	{
		if ($this->show_associations_tab !== $v || $v === true) {
			$this->show_associations_tab = $v;
			$this->modifiedColumns[] = WikiProjectSettingPeer::SHOW_ASSOCIATIONS_TAB;
		}
				
	}

  
	/**
	 * Get the ShowTagsTab column value.
	 *  
	 * @return boolean	  
	 */
	public function getShowTagsTab()
	{
		return $this->show_tags_tab;
	}


	/**
	 * Set the value of `show_tags_tab` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setShowTagsTab($v)
	{
		if ($this->show_tags_tab !== $v || $v === true) {
			$this->show_tags_tab = $v;
			$this->modifiedColumns[] = WikiProjectSettingPeer::SHOW_TAGS_TAB;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->project_id = $rs->getInt($startcol + 0);					
			$this->is_public = $rs->getBoolean($startcol + 1);					
			$this->wiki_type = $rs->getInt($startcol + 2);					
			$this->show_associations_tab = $rs->getBoolean($startcol + 3);					
			$this->show_tags_tab = $rs->getBoolean($startcol + 4);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating WikiProjectSetting object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(WikiProjectSettingPeer::DATABASE_NAME);
		$criteria->add(WikiProjectSettingPeer::PROJECT_ID, $this->project_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(WikiProjectSettingPeer::DATABASE_NAME);
		if ($this->isColumnModified(WikiProjectSettingPeer::PROJECT_ID)) $criteria->add(WikiProjectSettingPeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(WikiProjectSettingPeer::IS_PUBLIC)) $criteria->add(WikiProjectSettingPeer::IS_PUBLIC, $this->is_public);
		if ($this->isColumnModified(WikiProjectSettingPeer::WIKI_TYPE)) $criteria->add(WikiProjectSettingPeer::WIKI_TYPE, $this->wiki_type);
		if ($this->isColumnModified(WikiProjectSettingPeer::SHOW_ASSOCIATIONS_TAB)) $criteria->add(WikiProjectSettingPeer::SHOW_ASSOCIATIONS_TAB, $this->show_associations_tab);
		if ($this->isColumnModified(WikiProjectSettingPeer::SHOW_TAGS_TAB)) $criteria->add(WikiProjectSettingPeer::SHOW_TAGS_TAB, $this->show_tags_tab);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addWikiProjectSettings($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("project_id", "is_public", "wiki_type", "show_associations_tab", "show_tags_tab", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case WikiProjectSettingPeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case WikiProjectSettingPeer::IS_PUBLIC:
				return $this->getIsPublic();
				break;
		  
			case WikiProjectSettingPeer::WIKI_TYPE:
				return $this->getWikiType();
				break;
		  
			case WikiProjectSettingPeer::SHOW_ASSOCIATIONS_TAB:
				return $this->getShowAssociationsTab();
				break;
		  
			case WikiProjectSettingPeer::SHOW_TAGS_TAB:
				return $this->getShowTagsTab();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getProjectId();
				break;
  
			case 1:
				return $this->getIsPublic();
				break;
  
			case 2:
				return $this->getWikiType();
				break;
  
			case 3:
				return $this->getShowAssociationsTab();
				break;
  
			case 4:
				return $this->getShowTagsTab();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(WikiProjectSettingPeer::PROJECT_ID, $arr)) $this->setProjectId($arr[WikiProjectSettingPeer::PROJECT_ID]);
  
		if (array_key_exists(WikiProjectSettingPeer::IS_PUBLIC, $arr)) $this->setIsPublic($arr[WikiProjectSettingPeer::IS_PUBLIC]);
  
		if (array_key_exists(WikiProjectSettingPeer::WIKI_TYPE, $arr)) $this->setWikiType($arr[WikiProjectSettingPeer::WIKI_TYPE]);
  
		if (array_key_exists(WikiProjectSettingPeer::SHOW_ASSOCIATIONS_TAB, $arr)) $this->setShowAssociationsTab($arr[WikiProjectSettingPeer::SHOW_ASSOCIATIONS_TAB]);
  
		if (array_key_exists(WikiProjectSettingPeer::SHOW_TAGS_TAB, $arr)) $this->setShowTagsTab($arr[WikiProjectSettingPeer::SHOW_TAGS_TAB]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case WikiProjectSettingPeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case WikiProjectSettingPeer::IS_PUBLIC:
				$this->setIsPublic($value);
				break;
	  
			case WikiProjectSettingPeer::WIKI_TYPE:
				$this->setWikiType($value);
				break;
	  
			case WikiProjectSettingPeer::SHOW_ASSOCIATIONS_TAB:
				$this->setShowAssociationsTab($value);
				break;
	  
			case WikiProjectSettingPeer::SHOW_TAGS_TAB:
				$this->setShowTagsTab($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setProjectId($value);
				break;
  
			case 1:
				$this->setIsPublic($value);
				break;
  
			case 2:
				$this->setWikiType($value);
				break;
  
			case 3:
				$this->setShowAssociationsTab($value);
				break;
  
			case 4:
				$this->setShowTagsTab($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(WikiProjectSettingPeer::DATABASE_NAME);

		try {
			$con->begin();
			WikiProjectSettingPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(WikiProjectSettingPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = WikiProjectSettingPeer::doInsert($this, $con);
					$this->setNew(false);
				} else {
					WikiProjectSettingPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return WikiProjectSettingPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = WikiProjectSettingPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed project_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setProjectId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getProjectId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return WikiProjectSetting Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new WikiProjectSetting();
		$copyObj->setIsPublic($this->is_public);
		$copyObj->setWikiType($this->wiki_type);
		$copyObj->setShowAssociationsTab($this->show_associations_tab);
		$copyObj->setShowTagsTab($this->show_tags_tab);
		
		$copyObj->setNew(true);
		
		$copyObj->setProjectId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return WikiProjectSettingPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new WikiProjectSettingPeer();
		}
		return self::$peer;
	}

}
