<?php
/**
 * GForge 5.0 theme
 *
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel Perez daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/Layout.php');
require_once('html/HTMLWidget.php');
require_once('session/Session.php');
require_once('SystemUtils.php');
require_once('GFUrl.php');

class GFTheme extends Layout {
	/** misc color definitions */
	const COLOR_ROW_EVEN = '#EAEAEA';
	const COLOR_ROW_ODD = '#E0E0E0';
	const COLOR_TITLE_ROW = '#BBB';
	
	function getQuickJumpWrapper() {
		if (Session::getSession()->isLoggedIn()) {
			$lang = Session::getSession()->getLanguage();
			//$return = "<div id=\"quickJumpMenu\" class=\"quickJumpMenu\" style=\"visibility: hidden; position:absolute; z-index:2; max-height: 60%; overflow:auto;\">";
			$return = "<div id=\"quickJumpMenu\" class=\"quickJumpMenu\" style=\"visibility: hidden; position:absolute; z-index:2; overflow:auto;\">";
			$return .= '</div>';
			return $return;
		}
	}	
	
	/**
	 *	getQuickJump() - Local redefinition of the getQuickJump defined in the Layout class
	 *
	 */

	function getQuickJump() {
		if (Session::getSession()->isLoggedIn()) {
			$lang = Session::getSession()->getLanguage();
			$return = "<div id=\"quickJumpMenu\" class=\"quickJumpMenu\" style=\"visibility: hidden; position:absolute; z-index:2; max-height: 60%; overflow:auto;\">";
			$return .= 	"<table class='quickJumpMenu' summary=''>" . 
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/register/?action=ProjectAdd\">" . $lang->getText('QuickJump.AddProject') . "</a></td></tr>" .
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/my/reports/\">" . $lang->getText('QuickJump.Reports') . "</a></td></tr>" .
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/my/\">" . $lang->getText('QuickJump.MyStuff') . "</a></td></tr>" .
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/my/dashboard/\">" . $lang->getText('QuickJump.Dashboard') . "</a></td></tr>" .
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/my/activity/\">" . $lang->getText('QuickJump.Activity') . "</a></td></tr>" .
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/my/gantt/\">" . $lang->getText('QuickJump.Gantt') . "</a></td></tr>" .
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/my/?action=LatestForumMessages\">" . $lang->getText('QuickJump.Forums') . "</a></td></tr>";
			
			$ids=Session::getSession()->getUser()->getAllProjectIds();
			if (count($ids) > 0) {
				$sql="SELECT pr.unix_name,pr.project_name,pl.plugin_name 
				FROM project pr, project_plugin pp, plugin pl
				WHERE pr.project_id IN (".implode(',',$ids).")
				AND pr.project_id=pp.project_id AND
				pp.plugin_id=pl.plugin_id
				ORDER BY pr.unix_name";
				$con=Propel::getConnection();
				$stmt=$con->createStatement();
				$rs=$stmt->executeQuery($sql);
				$last_project='';
				while ($rs->next()) {
					$plugin_name = $rs->getString('plugin_name');
					// Ugly hack -- Jabber plugin shouldn't be shown since it doesn't have a main page
					if ($plugin_name == 'projectjabber') {
						continue;
					}
					$projname=$rs->getString('unix_name');
					if ($projname != $last_project) {
						$last_project=$projname;
						$return .= '<tr><td class=\'quickJumpMenu\'><a class=\'quickJumpMenu\' href="/gf/project/'.$projname.'/">'.$rs->getString('project_name').'</a></td></tr>';
					}
					$return .= '<tr><td class=\'quickJumpMenu\'><a class=\'quickJumpMenu\' href="/gf/project/'.$projname.'/'.$rs->getString('plugin_name').'/">&nbsp;&nbsp;'.ucwords($rs->getString('plugin_name')).'</a></td></tr>';
				}
			}
			$return .= '</table></div>';
			return $return;
		} else {
			return '';
		}
	}

	/**
	 *	header() - "steel theme" top of page
	 *
	 * @param	array	Header parameters array
	 */
	function header($params=array()) {
		if (isset($GLOBALS['headershown']) && $GLOBALS['headershown']) {
			return;
		} else {
			$GLOBALS['headershown']=true;
		}

		$session = Session::getSession();
		$User = $session->getUser();
		$language = $session->getLanguage();
		$this->headerStart($params);
		?>

<?php 
	//The following code is also used further down to select between div classes 'right' and 'rightnoleft'
	//If the criteria to choose between cases changes, the other code needs to be modified too.
	if (array_key_exists('project', $params) || array_key_exists('user', $params)) {?>
<body>
<?php } else { ?>
<body class='noleftbody'>
<?php } ?>

<script>
	function getPos(obj, direction) {	/*		direction == 0 ---> Top		direction != 0 ---> Left	*/
		var cur = 0;
		if (obj.offsetParent) {
			do {
				if (direction == 0)
					cur += obj.offsetTop;
				else
					cur += obj.offsetLeft;
			} while (obj = obj.offsetParent);
		}
		return cur;
	}
<?php
if (Session::getSession()->isLoggedIn()) {
?>
	function quickJumpMenu() {
		var menu = document.getElementById("quickJumpMenu");
		var icon = document.getElementById("quickJumpIcon");
		var othermenu = document.getElementById("SearchByIDMenu");
		if (othermenu)
			othermenu.style.visibility = "hidden";
		var t = getPos(icon, 0);
		var l = getPos(icon, 1);
		menu.style.top = ((t + parseInt(icon.height)) + "px");
		menu.style.left = (l + "px");
		if (menu.style.visibility == "visible")
			menu.style.visibility = "hidden";
		else
			menu.style.visibility = "visible";
	}
<?php
}
?>
	function expandFloatingMenu(id, icon) {
		var menu = document.getElementById(id);
		var icon = document.getElementById(icon);		
		var t = getPos(icon, 0);
		var l = getPos(icon, 1);
		menu.style.top = ((t + parseInt(icon.height)) + "px");
		menu.style.left = (l + "px");
		if (menu.style.visibility == "visible")
			menu.style.visibility = "hidden";
		else
			menu.style.visibility = "visible";
	}
	
	function SearchByIDMenu()
	{
		var menu = document.getElementById("SearchByIDMenu");
		var icon = document.getElementById("SearchByIDIcon");
		var othermenu = document.getElementById("quickJumpMenu");
		if (othermenu)
			othermenu.style.visibility = "hidden";
		var t = getPos(icon, 0);
		var l = getPos(icon, 1);
		menu.style.top = ((t + parseInt(icon.height)) + "px");
		menu.style.left = (l + "px");
		if (menu.style.visibility == "visible")
			menu.style.visibility = "hidden";
		else
			menu.style.visibility = "visible";
	}
</script>

<?php echo $this->getQuickJumpWrapper(); ?>

<div id="SearchByIDMenu" class="SearchByIDMenu" style="visibility: hidden; position:absolute; z-index:2; max-height: 25%; overflow:auto;">
	<form id="searchbyid" name="searchbyid" class="SearchByIDMenu" action=<?php	echo "\"" . GFUrl::getUrl()->baseURL('SearchById', '', 'search') . "\""; ?> method="POST">
	<table class="SearchByIDMenu" summary="">
		<tr><td class="SearchByIDMenu">
		<select name="searchtype" class="SearchByIDMenu">
			<?php
				$res = ActionManager::notify('SEARCH_BY_ID_LIST');
				foreach ($res as $r) {
					$t = $r->getResult();
					foreach ($t as $key => $value)
					{
						if ($key == "trackeritem") // dirty hack to get the tracker item option selected by default
							echo "<option value=\"$key\" selected>$value</option>";
						else
							echo "<option value=\"$key\">$value</option>";
					}
				}
			?>
		</select>
		</td></tr>
		<tr><td class="SearchByIDMenu">
		<strong>Item Id:&nbsp;</strong><input type="text" size="4" name="searchid" value="" />
		</td></tr>
		<tr><td class="SearchByIDMenu">
		<?php echo HTMLWidget::button("submit",$language->getText('Common.Search'),"searchbyidsubmit","searchbyidsubmit","")?>
		</td></tr>
	</table>
	</form>
</div>

<div id="header" style="min-width:803px;">
<script type="text/javascript">
	function quickJumpMenuLoad() {

		if (document.getElementById('quickJumpMenu').innerHTML == "") {
			new Ajax.Request('/gf/ajax/handler.php?action=GetQuickJumpMenu',
			  {
			    method:'get',
			    onSuccess: function(transport){
			      var response = transport.responseText || "couldn't get response from server";
			      document.getElementById('quickJumpMenu').innerHTML = response;
			      quickJumpMenu();
			      //alert("Success! \n\n" + response);
			    },
			    onFailure: function(){ alert('ajax call failed') }
			  });	
		} else {
			quickJumpMenu();
		}
	}
</script>
	
<?php 
echo $this->topTabs($params);
$src_qj = $this->getImgUrl("blue/quickjump_off.gif");
$src_qj_mo = $this->getImgUrl("blue/quickjump_on.gif");
$src_sbyid = $this->getImgUrl("blue/searchbyid_off.gif");
$src_sbyid_mo = $this->getImgUrl("blue/searchbyid_on.gif");
$src_help = $this->getImgUrl("blue/help_off.gif");
$src_help_mo = $this->getImgUrl("blue/help_on.gif");

//quick jump menu
if (Session::getSession()->isLoggedIn()) {
	echo "<img title='QuickJump menu' alt='' class='quickJumpMenu' id='quickJumpIcon' src='$src_qj' style='float:left;padding-right:10px; position:relative; top:0px;' onclick='quickJumpMenuLoad();' onmouseover='this.src=\"$src_qj_mo\";' onmouseout='this.src=\"$src_qj\";'/>";
}

//search by id menu
echo "<img title='Search by ID' alt='Search by ID' class='SearchByIDMenu' id='SearchByIDIcon' src='$src_sbyid' style='float:left; position:relative; top:0px;' onclick='SearchByIDMenu();' onmouseover='this.src=\"$src_sbyid_mo\";' onmouseout='this.src=\"$src_sbyid\";'/>";

//contextual help menu
echo "<a href=\"http://gforgegroup.com/es/help.php?section=".$this->getHelpSection()."\" target=\"_blank\" style='float:left; position:relative; top:0px;'><img title='Help' alt='Help' class='HelpMenu' id='helpIcon' src='$src_help' style='float:left; position:relative; top:0px;' onmouseover='this.src=\"$src_help_mo\";' onmouseout='this.src=\"$src_help\";'/></a>";
?>
		<div id="login" nowrap="nowrap"><?php
			if ($session->isLoggedIn()) {
				echo $language->getText('Common.Loggedin') .': '. $User->getUnixName() .' | <a href="'. GFUrl::getUrl()->baseURL('Logout','','account') .'">'. $language->getText('Common.Logout') .'</a>';
			} else {
				echo '<a href="'. GFUrl::getUrl()->baseURL('Login','','account',array('redirect'=>$_SERVER['REQUEST_URI'])).'">'. $language->getText('Common.Login').'</a> | <a href="'.GFUrl::getUrl()->baseURL('UserAdd','','account').'">'. $language->getText('Common.NewAccount').'</a>';
			}
			?>
		</div>
		<div class="clear"></div>
</div>
<div id="container">
<?php 
//The following code is also used further up to select between the default body class and 'bodynoleft'
//If the criteria to choose between cases changes, the other code needs to be modified too.
if (array_key_exists('project', $params) || array_key_exists('user', $params)) {

	?>
	<div id="left">
		<?php
		echo $this->secondTabs($params);
		?>
		<div class="clear"></div>
	</div>
	<div id="right">
	<?php
} else {
	?>
	<div id="rightnoleft">
	<?php
}

?>
                <div class="contentNav">
			<p id="crumbs"><?php echo $this->breadCrumbs($params['title']); ?></p>
                        <div class="clear"></div>
                </div>
		<div class="main">
<?php
if (isset($params['feedback']) && !empty($params['feedback'])) {
	echo '<span class="feedback">'. strip_tags($params['feedback'], '<br><br/><br />'). '</span><br />';
}
	}

	function footer($params=array()) {

	?>
	<center>
		<br /><br /><a href="http://gforge.org/"><img src="/themes/<?php echo $this->getName(); ?>/images/gforge-ee-logo-large.png" height="43" width="130" alt="Powered By GForge&reg; Collaborative Development Environment" border="0" /></a><br /><br />
	</center>
		</div>
		<div class="clear"></div>
	</div>
<?php
	$this->footerEnd($params);

	}

	function renderLocalNavElements($params) {
		$arr = $this->getTemplateNavElements($params);
		if (count($arr) == 0) {
			return '';
		}
		
		$nav = '<ul>';
		$first_li=true;
		foreach ($arr as $res) {
		/*	$nav .= '
		<	<ul>
		<!--	<li><a class="group" href="#">'.$res['title'].'</a></li> -->'; */
			$expandable='';
			$expandable_counter=0;
			
			foreach ($res['elements'] as $el) {
				$liclass='';
				if(isset($el['expandables']) && count($el['expandables'])>0) {
					$expandable = 'class="menuitem expandable"';
				}
				else {
					if($expandable == '' && $first_li) {
						$liclass='class="first_li"';
						$first_li=false;
					}
					$expandable='';
				}
				
				$nav .= '
				<li '.$liclass.'><a '.$expandable.' href="'.$el['link'].'"';
				if (isset($el['target']) && !empty($el['target'])) $nav .= ' target="'.$el['target'].'"';
				$nav .= '>'.$el['description'].'</a></li>';
				
				if(isset($el['expandables'])) {
					if($el['expanded']) {
						$nav = "<script>function expandableExpandItem() {ddaccordion.expandone('expandable',$expandable_counter);}</script>$nav";
					}
					$nav.= "\n<div class='submenu'><ul>";
					$ele_count = count ($el['expandables']);
					for($elec=0;$elec<$ele_count;$elec++) {
						$elexp = $el['expandables'][$elec];
						if($elec==$ele_count-1) {
							$ele_class='class="finalitem"';
						}
						else $ele_class='';
						
						$nav .= '
						<li><a '. $ele_class .' href="'.$elexp['link'].'"';
						if (isset($elexp['target']) && !empty($elexp['target'])) $nav .= ' target="'.$elexp['target'].'"';
						$nav .= '>'.$elexp['description'].'</a></li>';
					}
					$nav.="</ul></div>\n";
					$expandable_counter++;
					
				}
				
				
		
			}
		/*	$nav .= '
			</ul>';*/
		}
		return $nav.'</ul>';
	}

	/**
	 * infoTableTop() - Top HTML box
	 *
	 * @param   string  Box title
	 * @param   bool	Whether to echo or return the results
	 * @param   string  The box background color
	 */
	function infoTableTop($title) {
		return '
		<!-- Box Top Start -->
<table width="100%" class="tabular" cellpadding="5" cellspacing="1" summary="">
                        <tr class="th">
                                <th nowrap="nowrap">'.$title.'</th>
			</tr>
			<tr class="d">
				<td>
		<!-- Box Top end -->
		';

	}

	/**
	 * infoTableMiddle() - Middle HTML box
	 *
	 * @param   string  Box title
	 * @param   string  The box background color
	 */
	function infoTableMiddle($title) {
		return '
		<!-- Box Middle Start -->
				</td>
			</tr>
			<tr class="th">
				<th nowrap="nowrap">'.$title.'</th>
			</tr>
			<tr class="d">
				<td>

		<!-- Box Middle end -->
		';
	}

	/**
	 * infoTableBottom() - Bottom HTML box
	 *
	 * @param   bool	Whether to echo or return the results
	 */
	function infoTableBottom() {
		return '
		<!-- Box Bottom Start -->
				</td>
			</tr>
		</table>
		<!-- Box Bottom End -->';
	}

	function getTableRowClass($i) {
		if ($i % 2 == 0) {
			return 'l';
		} else {
			return 'd';
		}
	}

	function tableTop ($title_arr,$links_arr=false,$mod='') {
		$this->tableColCount=count($title_arr);
		$return = '
		<p>
		<table width="100%" class="tabular" summary="" cellpadding="5" cellspacing="1" '.$mod.'>
			<tr class="th">';
		
		$count=count($title_arr);
		if ($links_arr) {
			for ($i=0; $i<$count; $i++) {
				$return .= '
				<th nowrap="nowrap"><a href="'.$links_arr[$i].'">'.$title_arr[$i].'</a></th>';
			}
		} else {
			for ($i=0; $i<$count; $i++) {
				$return .= '
				<th nowrap="nowrap">'.$title_arr[$i].'</th>';
			}
		}
		return $return.'</tr>';
	}
	
	/**
	 * Builds a row that spans the entire table
	 */
	function tableFullRow($text) {
		$class = $this->getTableRowClass($this->tableRowCounter++);
		$return = '
			<tr class="'.$class.'">';
		$return .= '
				<td colspan="'.$this->tableColCount.'">'.$text.'</td>';
		$return .= '
			</tr>';
		return $return;
	}
	
	function tableBottom($button=array(), $button_enabled=array()) {
		$return = '';
		$class = $this->getTableRowClass($this->tableRowCounter++);

		if (count($button) < 1) {
			$return .= '<tr style="margin-top:0; margin-bottom:0; padding-top:0; padding-bottom:0"><td style="margin-top:0; margin-bottom:0; padding-top:0; padding-bottom:0" class="tFooter" valign="top" colspan="'.$this->tableColCount.'" align="right">&nbsp;</td></tr>';
		} else {
			$return .= '<tr style="margin-top:0; margin-bottom:0; padding-top:0; padding-bottom:0">';
			$return .= '<td style="margin-top:0; margin-bottom:0; padding-top:0; padding-bottom:0" class="tFooter" valign="top" colspan="'.$this->tableColCount.'" align="right">';

			$return .= '<div class="buttonLink">';

			$i = 0;			
			foreach ($button as $href => $text) {
				$text = trim($text);
				// Small hack that fixes an inconsistence (some buttons have the link inside the text)
				if (strpos($text, '<a ') === 0) {
					$data = StringUtils::extractDataFromLink($text);
					$href = $data['href'];
					$text = $data['text'];
				}
				
				if (isset($button_enabled[$i])) {
					if ($button_enabled[$i] == true) {
						$button_class = 'button';
						//$return .= '<span class="button"><a href="'. $href.'">'.$text.'</a></span>';
						$return .= '<a class="button" href="'. $href.'"><span>'.$text.'</span></a>'; //For styled buttons
					} else {
						$button_class = 'disabled_button';
						//$return .= '<span class="disabled_button">'.$text.'</span>';
						$return .= '<del class="button"><span>'.$text.'</span></del>'; //For styled buttons
					}
				} else {
					//$return .= '<span class="button"><a href="'. $href.'">'.$text.'</a></span>';
					$return .= '<a  class="button" href="'. $href.'"><span>'.$text.'</span></a>';
					$button_class = 'button';
				}	
				$i++;
			}
			$return = preg_replace('/ \\| $/', '', $return);
			$return .= '</div>';
			$return .= '</td></tr>';
		}
		$return .= '</table>
		</p>
';
		return $return;
	}
	
	/**
	 * tableRow build a <tr><td> set for this array
	 * @param	array	
	 */
	function tableRow($array,$array2=array(),$suppress_highlight=true,$trMod='') {
		$class = $this->getTableRowClass($this->tableRowCounter++);

		if ($suppress_highlight) {
			$highlight='';
		} else {
			$highlight = ' onmouseover="this.className=\'over\'" onmouseout="this.className=\''.$class.'\'"';
		}
		$return = '
			<tr class="'.$class.'" '.$highlight.' '.$trMod.'>';
		for ($i=0; $i<count($array); $i++) {
			if (isset($array2[$i])) {
				$str=$array2[$i];
			} else {
				$str='';
			}
			$return .= '<td '.$str.' valign="top">'.$array[$i].'</td>';
		}
		$return .= '
			</tr>';
		return $return;
	}

	public function getName() {
		return 'gforge5';
	}
	
	protected function renderTabs($tabs, $selectedTab, $nested, $params) {

		$count = count($tabs);
		$return = '';

//top row of tabs
		if (!$nested) {
			//hack to select class="selected" on the outer UL
			if ($tabs[0]['id']==$selectedTab) {
				$logoclass=' class="selected"';
			} else {
				$logoclass='';
			}
			if ($tabs[$count-1]['id']==$selectedTab) {
				$ulclass=' class="selected"';
			} else {
				$ulclass='';
			}
$return .= '
	<h1 id="logo"'.$logoclass.'><a href="/">MyGforge Home</a></h1>
	<ul id="mainNav"'.$ulclass.'>';
			$return .= '<li class="start"></li>';
			for ($i=0; $i < $count; $i++) {
				$tab = $tabs[$i];
				$issel = ($selectedTab && $tab['id'] == $selectedTab);
				if ($i==0 && !$issel) {
					$liclass='';
				} elseif ($i==$count-1 && !$issel) {
					$liclass=' class="end"';
				} elseif ($issel) {
					$liclass=' class="selected"';
				} else {
					$liclass='';
				}
				$return .= '
				<li'.$liclass.'><a '.(($issel) ? 'class="selected"' : '').' href="'.$tab['action'].'">'.$tab['text'].'</a></li>';
				if ($issel && $i!=$count-1) {
					$return .= '<li class="selectedBar"><img src="/themes/'.$this->getName().'/images/clear.png" width="1" height="1" alt="clear" /></li>';
				}
			}
$return .= '
	</ul>';
//side tabs, like for projects or user navigation
		} else {
			if (isset($params['project'])) {
				$local= $params['project']->getProjectName();
			} elseif ( isset($params['user']) ) {
				$local= $params['user']->getUnixName();
			} else {
				$local= '&nbsp;';
			}
			
			/*$return .= '
			<h1 class="navLabel">'.$local.'</h1>
			<ul id="sideNav">';*/

			$return .= "\n<h1 class='navLabel'>$local</h1>\n<div class='expandableMenu' >";
			for ($i=0; $i < $count; $i++) {
				$tab = $tabs[$i];
				
				if (!isset($tab['id'])) {
					// Empty tab, for some reason
					continue;
				}
				
				$issel = ($selectedTab && $tab['id'] == $selectedTab);
				//$return .= '<li><a '.(($issel) ? 'class="selected"' : '').' href="'.$tab['action'].'">'.$tab['text'].'</a>';
				//$expandable = '';
				if ($issel) {
					$localNavElements = $this->renderLocalNavElements($params);
				}
				$return .= '<a '.($issel ? 'class="menuitem selected"' : 'class="menuitem regular"'). (($issel && $localNavElements!='') ? ' style="margin-bottom:0px;" ':' ') . ' href="'.$tab['action'].'">'.$tab['text']."</a>\n";
				
				if ($issel) {
					$return .= $localNavElements;
				}
				//$return .= '</li>';
			}
			//$return .= '</ul>';
			$return .= '<h1 class="navLabel_bottom">&nbsp;</h1></div>';
		}
		return $return;
	}
}


	function popupHeader($theme, $title) {
	        $html = '<?xml version="1.0" encoding="UTF-8"?>
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
		<head>
			<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	        <title>'.$title.'</title>
	        <link href="/themes/'.$theme->getName().'/GFTheme.css" rel="stylesheet" type="text/css" />
	  </head>
	<body style="background: #ffffff;">
	<div style="background-color: #ffffff;">
		<div style="background-color: #ffffff; margin-top: 5px; margin-left: 5px;">
			<table border="0" cellspacing="2" cellpadding="2" summary=""><tr><td>';
	        return $html;
	}


	function popupFooter() {
	        $Lang = Session::getSession()->getLanguage();
	        
	        $html = '</td></tr></table><br />&nbsp;<br />'.
	        HTMLWidget::button("button",$Lang->getText('Common.Close'),"cancel","","window.close();") .
	        '&nbsp;<br />&nbsp;<br />&nbsp;<br />&nbsp;<br />&nbsp;</div></div>'.
	        '</body></html>';
	        return $html;
	}

?>
