<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$theme->header($params);
?>

<p>
	<strong><?php echo $Lang->getText('User.AddNew'); ?></strong>
</p>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('UserAddAction') ?>" method="POST">
	<table border="0">
		<tr>
			<td><strong><?php echo $Lang->getText('User.UnixNameName'); ?></strong><span class="required">*</span><br />
			<input type="text" name="unix_name" value="<?php echo $unix_name; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.Password'); ?></strong><span class="required">*</span><br />
			<input type="password" name="password" maxlength="32" value=""  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.ConfirmPassword'); ?></strong><span class="required">*</span><br />
			<input type="password" name="password_confirm" maxlength="32" value=""  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.TitleName'); ?></strong><br />
			<input type="text" name="title" value="<?php echo $title; ?>"  size="5" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.FirstnameName'); ?></strong><span class="required">*</span><br />
			<input type="text" name="firstname" value="<?php echo $firstname; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.LastnameName'); ?></strong><span class="required">*</span><br />
			<input type="text" name="lastname" value="<?php echo $lastname; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.EmailName'); ?></strong><span class="required">*</span><br />
			<emph><?php echo $Lang->getText('User.EmailDescription', array(GFConf::get('system.hostName'))); ?></emph><br />
			<input type="text" name="email" value="<?php echo $email; ?>"  size="30" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.TimezoneName'); ?></strong><br />
			<?php echo HTMLWidget::selectBoxFromArrays($TZs,$TZs,'timezone',$timezone,false); ?></td>
		</tr>
		<input type="hidden" name="date_format" value="Y-M-D"/>
<!--		<tr>
			<td><strong><?php echo $Lang->getText('User.DateFormatName'); ?></strong><br />
			<input type="text" name="date_format" value="<?php echo $date_format; ?>"  /></td>
		</tr> -->
		<tr>
			<td><strong><?php echo $Lang->getText('User.AddressName'); ?></strong><br />
			<input type="text" name="address" value="<?php echo $address; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.Address2Name'); ?></strong><br />
			<input type="text" name="address2" value="<?php echo $address2; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.PhoneName'); ?></strong><br />
			<input type="text" name="phone" value="<?php echo $phone; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.FaxName'); ?></strong><br />
			<input type="text" name="fax" value="<?php echo $fax; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.CountryCodeName'); ?></strong><span class="required">*</span><br />
			<?php
			$countries = CountryCodePeer::doSelect(new Criteria());
			echo HTMLWidget::select('ccode',$countries,$ccode,HTMLWidget::OPTION_NONE,false);
			?>
			</td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.LanguageIdName'); ?></strong><span class="required">*</span><br />
			<?php
			$languages = LanguagePeer::doSelect(new Criteria());
			echo HTMLWidget::select('language_id',$languages,$language_id,HTMLWidget::OPTION_NONE,false);
			?>
			</td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.ThemeIdName'); ?></strong><span class="required">*</span><br />
			<?php
			$themes = ThemePeer::doSelect(new Criteria());
			echo HTMLWidget::select('theme_id',$themes,$theme_id,HTMLWidget::OPTION_NONE,false);
			?>
			</td>
		</tr>
<?php if (GFConf::get('system.useCaptcha') == true) { ?>
		<tr>
			<td><strong><?php echo $Lang->getText('Captcha.Captcha'); ?></strong><span class="required">*</span><br />
				<img src="<?php echo GFUrl::getUrl()->baseUrl(); ?>?action=secureimage&sid=<?php echo md5(uniqid(time())); ?>" id="image" align="absmiddle" />
				<a href="<?php echo GFUrl::getUrl()->baseUrl(); ?>?action=secureimageaudio&sid=<?php echo md5(uniqid(time())); ?>" style="font-size: 11px">(Click here for audio version)</a><br /><br />
				<a href="#" onclick="document.getElementById('image').src = '<?php echo GFUrl::getUrl()->baseUrl(); ?>?action=secureimage&sid=' + Math.random(); return false">Request new image</a>
			</td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Captcha.EnterCaptcha'); ?></strong><span class="required">*</span><br />
				<input type="text" name="captcha_code" size="10" maxlength="6" />
			</td>
		</tr>
<?php } ?>
<?php if (GFConf::get('system.userRegClickLicense')) { ?>
		<tr>
			<td>
<pre>
<?php echo file_get_contents(GFConf::get('system.etcDir').'/USER_LICENSE'); ?>
</pre>
	</p>
	<p>
	<input type="checkbox" name="iagree" value="t" />&nbsp;<?php echo $Lang->getText('License.IHaveReadAndAgree'); ?>
			</td>
		</tr>
<?php } ?>
		<tr>
			<td colspan="2">
				<?php echo HTMLWidget::button("submit","" .   $Lang->getText('UserAddForm.submit') . " ","submit","","")?>
				<?php echo HTMLWidget::button("button", $Lang->getText('Common.Cancel'), "", "", "javascript:history.go(-1);"); ?>
			</td>
		</tr>
	</table>
</form>

<?php
$theme->footer($params);
?>
