<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

//
// This code shows a form for Project
//
require_once('core/ProjectPeer.php');
require_once('core/Project.php');
require_once('plugin/ActionManager.php');
require_once('html/HTMLWidget.php');
require_once('html/TroveRenderer.php');
require_once('exceptions/NotLoggedInException.php');
require_once('lib/GFExportImport.php');
require_once('html/templates/SiteAdminTemplate.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

$theme = new SiteAdminTemplate();

$params = array(
		'feedback' => isset($feedback) ? $feedback : '',
		'title' => $Lang->getText('ProjectTemplate.ImportPageName')
		);

$session = Session::getSession();

if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}

$allowed = true;

$theme->header($params);

$exportList = GFExportImport::getAllExports();

$exportSelectorString = '';

foreach($exportList as $projectName => $exports) {
	foreach($exports as $export) {
		$exportSelectorString .= "<option value='$projectName - $export'>$projectName - $export</option>\n";
	}
}

?>
<p><strong><?php echo $Lang->getText('ProjectTemplate.ImportFullWarning');?><strong></p>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('ProjectImportFullAction') ?>" method="POST" enctype="multipart/form-data"/>
<table border="0">
	<tr>
		<td>
			<strong><?php echo $Lang->getText('ProjectTemplate.ImportFull');?><strong><br/>
			<select name='exportSelector'>
			<?php echo $exportSelectorString ?>
			</select>
			</td>
	</tr>
	<tr>
		<td>
			<strong><?php echo $Lang->getText('ProjectTemplate.ImportProjectName');?><strong><br/>
			<input type='text' name='importProjectName' />
			</td>
	</tr>
	<tr>
		<td align="center">
<p><input type="checkbox" name="confirm" value="t" /><strong><?php echo $Lang->getText('ProjectTemplate.ImportFullConfirm');?><strong></p>
			<?php echo HTMLWidget::button("submit","" .   $Lang->getText('Common.Submit') . " ","submit","","")?>
			<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Back') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->currentBaseUrl('') . "'; ")?>
		</td>
	</tr>
</table>
</form>

<?php
$theme->footer($params);

?>
