<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a User and saves it to the 
// database
//
require_once('core/User.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if (!Session::getSession()->isSiteAdmin()) {
	throw new PermissionDeniedException();
}

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$user_id = $_POST['id'];
$User = UserPeer::retrieveByPk($user_id);

$errors = array();
$language = Language::getSessLang();

$password1 = isset($_POST['password1']) ? $_POST['password1'] : '';
$password2 = isset($_POST['password2']) ? $_POST['password2'] : '';

if ($password1 != $password2) $errors[] = Language::getSessText('User.PasswordsDontMatch');

if(count($errors) == 0) {
	$passresult = Validator::validatePassword($password1);
	if (!$passresult[0]) {
		$errors = array_merge($errors,$passresult[1]);
	}
}

if (count($errors) == 0) {
	$User->setPassword( $password1 );		// Password must not be sanitized

	$User->save();
	$url = GFUrl::getUrl();
	GFUrl::redirect($url->currentBaseURL('UserEdit'), array('user_id' => $user_id, 'feedback' => Language::getSessText('SiteAdmin.UserPassEdited')));
} else {
	$feedback = implode('<br />', $errors);
	GFUrl::redirect($url->currentBaseURL('UserPasswordEdit'), array('user_id' => $user_id, 'feedback' => $feedback));
}

?>