<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for $OBJECT deletion
//
require_once('core/UsergroupUserPeer.php');
require_once('core/UsergroupUser.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/templates/SiteAdminTemplate.php');
$theme = new SiteAdminTemplate();

$group_id = Validator::sanitizeInt($_GET['id']);
$remove_id = Validator::sanitizeInt($_GET['remove_id']);

$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupEdit').'&amp;id='.$group_id.'">'. $Lang->getText('Usergroup.EditGroup') .'</a>');
$theme->addBreadCrumb('<a href="'.GFUrl::getUrl()->currentBaseUrl('UsergroupBrowse').'">'.$Lang->getText('Usergroup.ManageGroups').'</a>');

$Group = UserPeer::retrieveByPk($_GET['id']);
$User = UserPeer::retrieveByPk($_GET['remove_id']);
if (!is_object($Group) || !Session::getSession()->isSiteAdmin()) {
	throw new PermissionDeniedException();
}
if ($Group->getIsGroup() != true) {
	throw new PermissionDeniedException();
}

$params = array(
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('UsergroupUser.DeletePageTitle')
		);

include('forms/UsergroupUserDelete-tpl.php');

?>
