<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez ruben@gforgegroup.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/MyTemplate.php');
require_once('plugins/tracker/lib/TrackerPeer.php');
require_once('plugins/tracker/lib/TrackerItemQuery.php');
require_once('lib/html/HTMLWidget.php');

$session = Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$Lang = $session->getLanguage();
$user = $session->getUser();

$theme = new MyTemplate();
$params = array(
	'title' => Language::getSessText('MyGanttView.Title'),
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'selectedbottomtab' => 'myganttview',
	'user' =>$user
	);

$trackers = array();
$trackers[0] = "Any tracker";

$projects = $user->getAllProjects();
foreach ($projects as $project) {
	$crit = new Criteria();
	$crit->add(TrackerPeer::PROJECT_ID, $project->getProjectId());
	$crit->add(TrackerPeer::DATATYPE, Tracker::DATATYPE_TASK);
	$allTrackers = TrackerPeer::doSelect($crit);
	
	foreach ($allTrackers as $tracker) {
		$trackers[$tracker->getTrackerId()] = $project->getProjectName().': '.$tracker->getTrackerName();
	}
}

$tracker_id=((isset($_REQUEST['tracker_id'])) ? $_REQUEST['tracker_id'] : 0 );
$begin=((isset($_REQUEST['start_date'])) ? $_REQUEST['start_date'] : 0 );
$end=((isset($_REQUEST['end_date'])) ? $_REQUEST['end_date'] : 0 );
$sortcol=((isset($_REQUEST['sortcol'])) ? $_REQUEST['sortcol'] : null );
$sortord=((isset($_REQUEST['sortord'])) ? $_REQUEST['sortord'] : 0 );
$res=((isset($_REQUEST['resolution'])) ? $_REQUEST['resolution'] : null );
$size=((isset($_REQUEST['size'])) ? $_REQUEST['size'] : 800 );

if ($begin=="0") {
	$begin = (time()-(30*86400));
} else {
	$begin = strtotime($begin);
}
if ($end=="0") {
	$end = time() + (30*86400);
} else {
	$end=strtotime($end);
}
if ($begin > $end) {
	$endtmp=$end;
	$end=$begin;
	$begin=$endtmp;
}

$sizes = array(640=>'640x480', 800=>'800x600', 1024=>'1024x768', 1600=>'1600x1200');
$resolutions = array('Months'=>'Months', 'Weeks'=>'Weeks', 'Days'=>'Days');

$theme->header($params);
?>
<script language="javascript" type="text/javascript" src="/datetimepicker.js">
</script>

<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
<table border="0" cellspacing="0" cellpadding="3" bgcolor="#E0E0E0">
<tr>
	<td><strong><?php echo $Lang->getText('Tracker.DatatypeTask') ?></strong></td>
	<td colspan="2"><strong><?php echo $Lang->getText('TrackerGanttView.DateRange') ?></strong></td>
	<td><strong><?php echo $Lang->getText('Tracker.SortCol') ?></strong></td>
</tr>
<tr>
	<td valign="top"><?php echo HTMLWidget::selectBoxFromAssoc($trackers,'tracker_id',$tracker_id,false,false) ?></td>
	<td valign="top"><input id="startdate" name="start_date" value="<?php echo date('M d Y',$begin); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('startdate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td valign="top"><input id="enddate" name="end_date" value="<?php echo date('M d Y',$end); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('enddate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td valign="top"><?php echo HTMLWidget::selectBoxFromAssoc(TrackerItemQuery::getAvailableSortColumns(),'sortcol',$sortcol,false,false) ?></td>
</tr>
<tr>
	<td><strong><?php echo $Lang->getText('Tracker.SortOrd') ?></strong></td>
	<td><strong><?php echo $Lang->getText('TrackerGanttView.Resolution') ?></strong></td>
	<td><strong><?php echo $Lang->getText('TrackerGanttView.Size') ?></strong></td>
	<td rowspan="2" align="center"><?php echo HTMLWidget::button("submit", $Lang->getText('Common.Submit'), "submit"); ?></td>
</tr>
<tr>
	<td valign="top"><?php echo HTMLWidget::selectBoxFromAssoc(TrackerItemQuery::getAvailableSortOrd(),'sortord',$sortord,false,false) ?></td>
	<td valign="top"><?php echo HTMLWidget::selectBoxFromAssoc($resolutions,'resolution',$res,false,false) ?></td>
	<td valign="top"><?php echo HTMLWidget::selectBoxFromAssoc($sizes,'size',$size,false,false) ?></td>
</tr>
</table>
</form>
<?php
$querystring  = '&amp;start_date='.date('Y-m-d', $begin);
$querystring .= '&amp;end_date='.date('Y-m-d', $end).'&amp;tracker_id='.$tracker_id;
$querystring .= '&amp;sortcol='.$sortcol.'&amp;sortord='.$sortord.'&amp;resolution='.$res;
$querystring .= '&amp;size='.$size;
?>
<br />
<img src="/gf/my/gantt/?action=GanttGraph<?php echo $querystring ?>"/>
<?php
echo $theme->footer();
?>
