<?php

/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. P�rez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


require_once('GFUrl.php');
require_once('exceptions/PermissionDeniedException.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

// $_POST['allPlugins'] has the list of all the available plugins, while
// $_POST['plugins'] has the list of the selected plugins only

$enabledPlugins = isset($_POST['plugins']) ? $_POST['plugins'] : array();
$disabledPlugins = array_diff($_POST['allPlugins'], $enabledPlugins);

$project = GFUrl::getUrl()->getProject();
$session = Session::getSession();
$lang = $session->getLanguage();
if (!$project->userIsAdmin()) {
	// Only project admins can change member information
	throw new PermissionDeniedException();
}

foreach ($enabledPlugins as $exclusive_type => $pluginName) {
	// the array keys are either indexes or the name of the exclusive_type
	if (is_numeric($exclusive_type)) $exclusive_type = null;
	
	// If exclusive_type is set and the name isn't, it means the user selected "None"
	// from that exclusive_type list, so we don't have to enable anything now
	// (the plugin will be disabled later, in the next loop)
	if ($exclusive_type && empty($pluginName)) continue;
	
	$project->enablePlugin($pluginName);
}

foreach ($disabledPlugins as $pluginName) {
	$project->disablePlugin($pluginName);
}

$feedback = $lang->getText('Feedback.SavedChanges');
include(dirname(__FILE__).'/index.php');

?>